#include "fonts.h"
#include <math.h>

void FontExtractor::writezeros(int numzero){
	for(int a = 0; a < numzero; a++){
		fputc(0x00,fw);
	}
}

void FontExtractor::writeheader(){
	fputc(0x42,fw);
	fputc(0x4d,fw);
	writezeros(8);
	fputc(0x36,fw);
	writezeros(3);
	fputc(0x28,fw);
	writezeros(3);
	fputc(0x91,fw);
	writezeros(3);
	fputc(0x49,fw);
	writezeros(3);
	fputc(0x01,fw);
	writezeros(1);
	fputc(0x18,fw);
	writezeros(9);
	fputc(0x12,fw);
	fputc(0x0b,fw);
	writezeros(2);
	fputc(0x12,fw);
	fputc(0x0b,fw);
	writezeros(10);
}

void FontExtractor::writebits(int bytes, int num, int a, int b){
	int z;
	int y;
	for(int x = 7; x >= 0; x--){
		z = (int)(pow(2,x));
		y = bytes/z;
		bytes-=(z*y);
		pixels[(a*8)+(7-x)][(b*8)+num] = y;
	}
}

void FontExtractor::writebitmap(){
	int bytes;
	bool loop = true;
	while(loop){
		for(int b = 0; b < 8; b++){
			for(int a = 0; a < 16; a++){
				for(int num = 0; num < 8; num++){
						bytes = fgetc(fp);
						writebits(bytes,num,a,b);
				}
			}
		}
		break;
	}
}

void FontExtractor::drawbitmap(){
	int num;
	for(int d = 0; d < 145; d++){
		fputc(0x00,fw);
		fputc(0x00,fw);
		fputc(0xff,fw);
	}
	fputc(0x00,fw);
	for(int a = 63; a >= 0; a--){
		for(int b = 0; b < 128; b++){
			if(b%8==0){
				fputc(0x00,fw);
				fputc(0x00,fw);
				fputc(0xff,fw);
			}
			num = pixels[b][a];
			if(num == 0){
				for(int c = 0; c < 3; c++){
					fputc(0x00,fw);
				}
			}
			else{
				for(int c = 0; c < 3; c++){
					fputc(0xff,fw);
				}
			}
			if(b == 127){
				fputc(0x00,fw);
				fputc(0x00,fw);
				fputc(0xff,fw);
				fputc(0x00,fw);
			}
		}
		if(a%8==0){
			for(int d = 0; d < 145; d++){
				fputc(0x00,fw);
				fputc(0x00,fw);
				fputc(0xff,fw);
			}
			fputc(0x00,fw);
		}
	}
}

void FontExtractor::writeend(){
	writezeros(2);
}

void FontExtractor::changefonttobmp(char *file, char* path){
	char* file1 = NULL;
	char* file2 = NULL;
	if((fp = fopen(file1,"rb"))==NULL){
		exit(0);
	}
	fw = fopen(file2,"wb");
	writeheader();
	writebitmap();
	drawbitmap();
	writeend();
	fclose(fp);
	fclose(fw);
}