#ifndef GLOBALS_H
#define GLOBALS_H

#include <windows.h>
#include "DDUtil.h"

#define SAFE_RELEASE(p) 	 { if(p) { (p)->Release(); (p)=NULL; } }
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }

const int EDITMAPS		= 30;
const int EDITSPEECH	= 31;
const int EDITSAVEDGAME	= 32;

const int BRITDAT		= 40;
const int CASTLEDAT		= 41;
const int DWELLINGDAT	= 42;
const int KEEPDAT		= 43;
const int TOWNEDAT		= 44;
const int UNDERDAT		= 45;

const int CASTLETALK	= 50;
const int DWELLINGTALK	= 51;
const int KEEPTALK		= 52;
const int TOWNETALK		= 53;

const int FONTDAT		= 60;

const int CHECKHIGHLIGHTTILE	= 1;
const int UNCHECKHIGHLIGHTTILE	= 2;

const int WINDOW_WIDTH	= 640;
const int WINDOW_HEIGHT	= 416;

const int ID_MAP_BRIT				= 9100;
const int ID_MAP_UNDER				= 9101;
const int ID_MAP_BRITAIN			= 9102;
const int ID_MAP_JHELOM				= 9103;
const int ID_MAP_MINOC				= 9104;
const int ID_MAP_MOONGLOW			= 9105;
const int ID_MAP_NEWMAGINCIA		= 9106;
const int ID_MAP_SKARABRAE			= 9107;
const int ID_MAP_TRINSIC			= 9108;
const int ID_MAP_YEW				= 9109;
const int ID_MAP_CASTLEBLACKTHORN	= 9110;
const int ID_MAP_CASTLEBRITISH		= 9111;
const int ID_MAP_EMPATHABBEY		= 9112;
const int ID_MAP_LYCAEUM			= 9113;
const int ID_MAP_SERPENTSHOLD		= 9114;
const int ID_MAP_GRENDEL			= 9115;
const int ID_MAP_IOLO				= 9116;
const int ID_MAP_SINVRAAL			= 9117;
const int ID_MAP_SUTEK				= 9118;
const int ID_MAP_BUCSDEN			= 9119;
const int ID_MAP_COVE				= 9120;
const int ID_MAP_EASTBRITAINNY		= 9121;
const int ID_MAP_NORTHBRITAINNY		= 9122;
const int ID_MAP_PAWS				= 9123;
const int ID_MAP_WESTBRITAINNY		= 9124;
const int ID_MAP_ARARAT				= 9125;
const int ID_MAP_BORDERMARCH		= 9126;
const int ID_MAP_FARTHING			= 9127;
const int ID_MAP_STONEKEEP			= 9128;
const int ID_MAP_WINDEMERE			= 9129;
const int ID_MAP_FOGSBANE			= 9130;
const int ID_MAP_GREYHAVEN			= 9131;
const int ID_MAP_WAVEGUIDE			= 9132;
const int ID_MAP_STORMCROW			= 9133;

extern int			previousmode;
extern int			currentmode;
extern int			currentmap;

extern bool			wrap;
extern bool			animate;
extern bool			lbuttondown;

extern int			currentxpos;
extern int			currentypos;

extern int			maxX;
extern int			maxY;

extern int			currentedittile;
extern int			currenttileselection;

extern CDisplay*	DDisplay;

extern char			path[_MAX_PATH];

extern bool			highlighttiles;

extern bool			lineofsight;

#endif