#include <shlobj.h>
#include "menu.h"
#include "globals.h"

static HMENU hMenu;
static HMENU hSubMenu;
static HMENU hSubPopup;
static HMENU WorldMapPopup;
static HMENU CastleMapPopup;
static HMENU DwellingMapPopup;
static HMENU KeepMapPopup;
static HMENU TowneMapPopup;

static HMENU LighthouseMapPopup;
static HMENU VillageMapPopup;

static HMENU TalkPopup;

static HMENU Options;

static HMENU FontPopup;
static HMENU PicturePopup;

static HMENU MapLevelMenu;

void makeMenu(HWND hWnd){
	hMenu = CreateMenu();
	
	hSubMenu = CreatePopupMenu();
	AppendMenu(hMenu,MF_STRING|MF_POPUP,(UINT)hSubMenu,"File");
	AppendMenu(hSubMenu,MF_STRING,ID_DIRECTORY_OPEN,"Open");
	AppendMenu(hSubMenu,MF_STRING,ID_FILE_SAVE,"Save");
	AppendMenu(hSubMenu,MF_STRING,ID_FILE_EXIT,"Exit");
	
	hSubMenu = CreatePopupMenu();
	AppendMenu(hMenu,MF_STRING|MF_POPUP,(UINT)hSubMenu,"Edit");
	WorldMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)WorldMapPopup,"World Maps");
	AppendMenu(WorldMapPopup,MF_STRING|MF_GRAYED,ID_MAP_BRIT,"Britannia");
	AppendMenu(WorldMapPopup,MF_STRING|MF_GRAYED,ID_MAP_UNDER,"Underworld");
	TowneMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)TowneMapPopup,"Town Maps");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_BRITAIN,"Britain");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_JHELOM,"Jhelom");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_MINOC,"Minoc");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_MOONGLOW,"Moonglow");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_NEWMAGINCIA,"New Magincia");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_SKARABRAE,"Skara Brae");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_TRINSIC,"Trinsic");
	AppendMenu(TowneMapPopup,MF_STRING,ID_MAP_YEW,"Yew");
	CastleMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)CastleMapPopup,"Castle Maps");
	AppendMenu(CastleMapPopup,MF_STRING,ID_MAP_CASTLEBLACKTHORN,"Lord Blackthorn's Castle");
	AppendMenu(CastleMapPopup,MF_STRING,ID_MAP_CASTLEBRITISH,"Lord British's Castle");
	DwellingMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)DwellingMapPopup,"Dwelling Maps");
	AppendMenu(DwellingMapPopup,MF_STRING,ID_MAP_GRENDEL,"Grendel's Hut");
	AppendMenu(DwellingMapPopup,MF_STRING,ID_MAP_IOLO,"Iolo's Hut");
	AppendMenu(DwellingMapPopup,MF_STRING,ID_MAP_SINVRAAL,"Sin Vraal's Hut");
	AppendMenu(DwellingMapPopup,MF_STRING,ID_MAP_SUTEK,"Sutek's Hut");
	VillageMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)VillageMapPopup,"Village Maps");
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_BUCSDEN,"Bucaneer's Den");
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_COVE,"Cove");
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_PAWS,"Paws");
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_EASTBRITAINNY,"East Britanny");
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_NORTHBRITAINNY,"North Britanny");	
	AppendMenu(VillageMapPopup,MF_STRING,ID_MAP_WESTBRITAINNY,"West Britanny");
	KeepMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)KeepMapPopup,"Keep Maps");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_ARARAT,"Ararat");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_BORDERMARCH,"Bordermarch");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_FARTHING,"Farthing");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_STONEKEEP,"Stonekeep");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_WINDEMERE,"Windemere");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_EMPATHABBEY,"Empath Abbey");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_LYCAEUM,"Lycaeum");
	AppendMenu(KeepMapPopup,MF_STRING,ID_MAP_SERPENTSHOLD,"Serpent's Hold");
	LighthouseMapPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)LighthouseMapPopup,"Lighthouse Maps");
	AppendMenu(LighthouseMapPopup,MF_STRING,ID_MAP_FOGSBANE,"Fogsbane");
	AppendMenu(LighthouseMapPopup,MF_STRING,ID_MAP_GREYHAVEN,"Greyhaven");
	AppendMenu(LighthouseMapPopup,MF_STRING,ID_MAP_STORMCROW,"Stormcrow");
	AppendMenu(LighthouseMapPopup,MF_STRING,ID_MAP_WAVEGUIDE,"Waveguide");
	hSubPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)hSubPopup,"Dungeon Maps");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Covetous");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Deciet");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Despise");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Destard");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Doom");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Hythloth");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Shame");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Wrong");
	AppendMenu(hSubMenu,MF_SEPARATOR,0,0);
	TalkPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)TalkPopup,"NPC Speech");
	AppendMenu(TalkPopup,MF_STRING,ID_TALK_CASTLE,"NPC's in castles");
	AppendMenu(TalkPopup,MF_STRING,ID_TALK_DWELLING,"NPC's in dwellings");
	AppendMenu(TalkPopup,MF_STRING,ID_TALK_KEEP,"NPC's in keeps");
	AppendMenu(TalkPopup,MF_STRING,ID_TALK_TOWNE,"NPC's in townes");
	AppendMenu(hSubMenu,MF_SEPARATOR,0,0);
	AppendMenu(hSubMenu,MF_STRING|MF_GRAYED,ID_HELP_ABOUT,"Save Game");
	AppendMenu(hSubMenu,MF_SEPARATOR,0,0);
	FontPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)FontPopup,"Font");
	AppendMenu(FontPopup,MF_STRING,ID_CHANGEFONT2BITMAP,"Change Font to Bitmap");
	AppendMenu(FontPopup,MF_STRING,ID_CHANGEBITMAP2FONT,"Change Bitmap to Font");
	AppendMenu(hSubMenu,MF_SEPARATOR,0,0);
	PicturePopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)PicturePopup,"Graphics");
	AppendMenu(PicturePopup,MF_STRING,ID_EXTRACTGRAPHICS,"Extract Graphics");
	AppendMenu(PicturePopup,MF_STRING,ID_INSERTGRAPHICS,"Insert Graphics");
	AppendMenu(hSubMenu,MF_SEPARATOR,0,0);
	hSubPopup = CreatePopupMenu();
	AppendMenu(hSubMenu,MF_STRING|MF_POPUP|MF_GRAYED,(UINT)hSubPopup,"Miscellaneous");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Battle grounds");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Camp grounds");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Introduction graphics");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Shrines");
	AppendMenu(hSubPopup,MF_STRING,ID_HELP_ABOUT,"Sign Posts");

	hSubMenu = CreatePopupMenu();
	AppendMenu(hMenu,MF_STRING|MF_POPUP,(UINT)hSubMenu,"Help");
	AppendMenu(hSubMenu,MF_STRING,ID_HELP_ABOUT,"About");
	
	SetMenu(hWnd,hMenu);
}

void changemenu(HWND hWnd, int id){
	hMenu = GetMenu(hWnd);
	switch(id){
	case BRITDAT:
		EnableMenuItem(hMenu,(UINT)WorldMapPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_MAP_BRIT,MF_ENABLED);
		break;
	case CASTLEDAT:
		EnableMenuItem(hMenu,(UINT)CastleMapPopup,MF_ENABLED);
		EnableMenuItem(hMenu,(UINT)VillageMapPopup,MF_ENABLED);
		break;
	case DWELLINGDAT:
		EnableMenuItem(hMenu,(UINT)DwellingMapPopup,MF_ENABLED);
		EnableMenuItem(hMenu,(UINT)LighthouseMapPopup,MF_ENABLED);
		break;
	case KEEPDAT:
		EnableMenuItem(hMenu,(UINT)KeepMapPopup,MF_ENABLED);
		break;
	case TOWNEDAT:
		EnableMenuItem(hMenu,(UINT)TowneMapPopup,MF_ENABLED);
		break;
	case UNDERDAT:
		EnableMenuItem(hMenu,(UINT)WorldMapPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_MAP_UNDER,MF_ENABLED);
		break;
	case CASTLETALK:
		EnableMenuItem(hMenu,(UINT)TalkPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_TALK_CASTLE,MF_ENABLED);
		break;
	case DWELLINGTALK:
		EnableMenuItem(hMenu,(UINT)TalkPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_TALK_DWELLING,MF_ENABLED);
		break;
	case KEEPTALK:
		EnableMenuItem(hMenu,(UINT)TalkPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_TALK_KEEP,MF_ENABLED);
		break;
	case TOWNETALK:
		EnableMenuItem(hMenu,(UINT)TalkPopup,MF_ENABLED);
		EnableMenuItem(hMenu,ID_TALK_TOWNE,MF_ENABLED);
		break;
	case FONTDAT:
		EnableMenuItem(hMenu,(UINT)FontPopup,MF_ENABLED);
		break;
	default:
		break;
	}
	EnableMenuItem(hMenu,(UINT)PicturePopup,MF_ENABLED);
}

void changeoptionsmenu(HWND hWnd){
	hMenu = GetMenu(hWnd);
	switch(previousmode){
	case EDITMAPS:
		RemoveMenu(hMenu,(UINT)Options,MF_BYCOMMAND);
		break;
	default:
		break;
	}
	switch(currentmode){
	case EDITMAPS:
		Options = CreatePopupMenu();
		InsertMenu(hMenu,2,MF_STRING|MF_POPUP|MF_BYPOSITION,(UINT)Options,"Options");
		AppendMenu(Options,MF_STRING,ID_HIGHLIGHTTILES,"Highlight Unchangeable Tiles");
		AppendMenu(Options,MF_STRING|MF_GRAYED,ID_HELP_ABOUT,"Enable Etherial Mode");
		AppendMenu(Options,MF_STRING|MF_GRAYED,ID_HELP_ABOUT,"Enable Night");
		AppendMenu(Options,MF_STRING,ID_LINEOFSIGHT,"Enable Line of Sight");
		AppendMenu(Options,MF_STRING|MF_GRAYED,ID_HELP_ABOUT,"Show NPC's");
		AppendMenu(Options,MF_STRING|MF_GRAYED,ID_HELP_ABOUT,"Show NPC Movement");
		AppendMenu(Options,MF_SEPARATOR,ID_HELP_ABOUT,0);
		AppendMenu(Options,MF_STRING,ID_GOTO_POS,"Go to position");
		break;
	default:
		break;
	}
	SetMenu(hWnd,hMenu);
}

bool OnOpenDirectory(HWND hWnd, MiscFunc* miscfunc){
	BROWSEINFO dirbrowseinfo;
	LPITEMIDLIST directoryinfo;
	strcpy(path,"C:\\ultima5"); 
	memset (&dirbrowseinfo, 0, sizeof(dirbrowseinfo)); 
	dirbrowseinfo.hwndOwner = hWnd;
	dirbrowseinfo.ulFlags = BIF_EDITBOX|BIF_RETURNONLYFSDIRS|BIF_VALIDATE;
	dirbrowseinfo.lParam = (LPARAM)path; 
	dirbrowseinfo.lpszTitle = "Select the folder where to find Ultima V";
	directoryinfo = SHBrowseForFolder(&dirbrowseinfo);
	if(directoryinfo != NULL){
		SHGetPathFromIDList(directoryinfo, path);
		return miscfunc->checku5directory(hWnd);
	}
	else{
	}
	return false;
}

void changelevelmenu(HWND hWnd, int level){
	hMenu = GetMenu(hWnd);
	RemoveMenu(Options,(UINT)MapLevelMenu,MF_BYCOMMAND);
	MapLevelMenu = CreatePopupMenu();
	InsertMenu(Options,0,MF_STRING|MF_POPUP|MF_BYPOSITION,(UINT)MapLevelMenu,"Change Level");
	switch(level){
	case 5:
		InsertMenu(MapLevelMenu,0,MF_STRING|MF_BYPOSITION,ID_LEVEL5,"Level 5");
	case 4:
		InsertMenu(MapLevelMenu,0,MF_STRING|MF_BYPOSITION,ID_LEVEL4,"Level 4");
	case 3:
		InsertMenu(MapLevelMenu,0,MF_STRING|MF_BYPOSITION,ID_LEVEL3,"Level 3");
	case 2:
		InsertMenu(MapLevelMenu,0,MF_STRING|MF_BYPOSITION,ID_LEVEL2,"Level 2");
	case 1:
		InsertMenu(MapLevelMenu,0,MF_STRING|MF_BYPOSITION,ID_LEVEL1,"Level 1");
	default:
		break;
	}
}

void checkmapoptionsmenu(HWND hWnd, int option){
	hMenu = GetMenu(hWnd);
	switch(option){
	case UNCHECKHIGHLIGHTTILE:
		CheckMenuItem(hMenu,ID_HIGHLIGHTTILES,MF_UNCHECKED);
		highlighttiles = false;
		break;
	case CHECKHIGHLIGHTTILE:
		CheckMenuItem(hMenu,ID_HIGHLIGHTTILES,MF_CHECKED);
		highlighttiles = true;
		break;
	default:
		break;
	}
}

void checklevelmenu(HWND hWnd, int level){

	UINT level1flags;
	UINT level2flags;
	UINT level3flags;
	UINT level4flags;
	UINT level5flags;

	level1flags = MF_UNCHECKED;
	level2flags = MF_UNCHECKED;
	level3flags = MF_UNCHECKED;
	level4flags = MF_UNCHECKED;
	level5flags = MF_UNCHECKED;

	switch(level){
	case 1:
		level1flags = MF_CHECKED;
		break;
	case 2:
		level2flags = MF_CHECKED;
		break;
	case 3:
		level3flags = MF_CHECKED;
		break;
	case 4:
		level4flags = MF_CHECKED;
		break;
	case 5:
		level5flags = MF_CHECKED;
		break;
	default:
		break;
	}

	hMenu = GetMenu(hWnd);
	CheckMenuItem(hMenu,ID_LEVEL1,level1flags);
	CheckMenuItem(hMenu,ID_LEVEL2,level2flags);
	CheckMenuItem(hMenu,ID_LEVEL3,level3flags);
	CheckMenuItem(hMenu,ID_LEVEL4,level4flags);
	CheckMenuItem(hMenu,ID_LEVEL5,level5flags);
}

void changelineofsight(){
	if(lineofsight == true){
		lineofsight = false;
		CheckMenuItem(hMenu,ID_LINEOFSIGHT,MF_UNCHECKED);
	}
	else{
		lineofsight = true;
		CheckMenuItem(hMenu,ID_LINEOFSIGHT,MF_CHECKED);
	}
}