#include <stdio.h>
#include "globals.h"
#include "miscfunc.h"
#include "menu.h"
#include "ddinit.h"

static int allwater[51] = {0,1,14,16,31,47,107,119,120,121,124,128,
		135,136,137,140 ,151,153,154,155,156,159,167,169,170,173,174,175,176,
		177 ,184,185,186,187,188,189,192,195,200,201,204,208,211,216 ,217,
		220,224,240,241,242,245};

static MAP map_brit[256][256];
static MAP map_under[256][256];
static MAP map_britain[32][32][2];
static MAP map_jhelom[32][32][2];
static MAP map_minoc[32][32][2];
static MAP map_moonglow[32][32][2];
static MAP map_newmagincia[32][32][2];
static MAP map_skarabrae[32][32][2];
static MAP map_trinsic[32][32][2];
static MAP map_yew[32][32][2];
	
static MAP map_castleblackthorn[32][32][5];
static MAP map_castlebritish[32][32][5];
	
static MAP map_empathabbey[32][32][3];
static MAP map_lycaeum[32][32][3];
static MAP map_serpentshold[32][32][3];
	
static MAP map_grendel[32][32];
static MAP map_iolo[32][32];
static MAP map_sinvraal[32][32];
static MAP map_sutek[32][32];
	
static MAP map_bucsden[32][32];
static MAP map_cove[32][32];
static MAP map_eastbritainny[32][32];
static MAP map_northbritainny[32][32];
static MAP map_paws[32][32];
static MAP map_westbritainny[32][32];
	
static MAP map_ararat[32][32][2];
static MAP map_bordermarch[32][32][2];
static MAP map_farthing[32][32];
static MAP map_stonekeep[32][32];
static MAP map_windemere[32][32];
	
static MAP map_fogsbane[32][32][3];
static MAP map_greyhaven[32][32][3];
static MAP map_waveguide[32][32][3];
static MAP map_stormcrow[32][32][3];

//-----------------------------------------------------------------------------
// Name: backupmap
// Desc: backup the map
//-----------------------------------------------------------------------------

void MiscFunc::backupmap(){
	int x = 32;
	int y = 32;
	int z = 1;
	MAP *map1;
	switch(previousmap){
	case ID_MAP_BRIT:
		map1 = &map_brit[0][0];
		x = 256;
		y = 256;
		break;
	case ID_MAP_UNDER:
		map1 = &map_under[0][0];
		x = 256;
		y = 256;
		break;
	case ID_MAP_BRITAIN:
		map1 = &map_britain[0][0][level];
		z = 2;
		break;
	case ID_MAP_JHELOM:
		map1 = &map_jhelom[0][0][level];
		z = 2;
		break;
	case ID_MAP_MINOC:
		map1 = &map_minoc[0][0][level];
		z = 2;
		break;
	case ID_MAP_MOONGLOW:
		map1 = &map_moonglow[0][0][level];
		z = 2;
		break;
	case ID_MAP_NEWMAGINCIA:
		map1 = &map_newmagincia[0][0][level];
		z = 2;
		break;
	case ID_MAP_SKARABRAE:
		map1 = &map_skarabrae[0][0][level];
		z = 2;
		break;
	case ID_MAP_TRINSIC:
		map1 = &map_trinsic[0][0][level];
		z = 2;
		break;
	case ID_MAP_YEW:
		map1 = &map_yew[0][0][level];
		z = 2;
		break;
	case ID_MAP_CASTLEBLACKTHORN:
		map1 = &map_castleblackthorn[0][0][level];
		z = 5;
		break;
	case ID_MAP_CASTLEBRITISH:
		map1 = &map_castlebritish[0][0][level];
		z = 5;
		break;
	case ID_MAP_EMPATHABBEY:
		map1 = &map_empathabbey[0][0][level];
		z = 3;
		break;
	case ID_MAP_LYCAEUM:
		map1 = &map_lycaeum[0][0][level];
		z = 3;
		break;
	case ID_MAP_SERPENTSHOLD:
		map1 = &map_serpentshold[0][0][level];
		z = 3;
		break;
	case ID_MAP_GRENDEL:
		map1 = &map_grendel[0][0];
		break;
	case ID_MAP_IOLO:
		map1 = &map_iolo[0][0];
		break;
	case ID_MAP_SINVRAAL:
		map1 = &map_sinvraal[0][0];
		break;
	case ID_MAP_SUTEK:
		map1 = &map_sutek[0][0];
		break;
	case ID_MAP_BUCSDEN:
		map1 = &map_bucsden[0][0];
		break;
	case ID_MAP_COVE:
		map1 = &map_cove[0][0];
		break;
	case ID_MAP_EASTBRITAINNY:
		map1 = &map_eastbritainny[0][0];
		break;
	case ID_MAP_NORTHBRITAINNY:
		map1 = &map_northbritainny[0][0];
		break;
	case ID_MAP_PAWS:
		map1 = &map_paws[0][0];
		break;
	case ID_MAP_WESTBRITAINNY:
		map1 = &map_westbritainny[0][0];
		break;
	case ID_MAP_ARARAT:
		map1 = &map_ararat[0][0][level];
		z = 2;
		break;
	case ID_MAP_BORDERMARCH:
		map1 = &map_bordermarch[0][0][level];
		z = 2;
		break;
	case ID_MAP_FARTHING:
		map1 = &map_farthing[0][0];
		break;
	case ID_MAP_STONEKEEP:
		map1 = &map_stonekeep[0][0];
		break;
	case ID_MAP_WINDEMERE:
		map1 = &map_windemere[0][0];
		break;
	case ID_MAP_FOGSBANE:
		map1 = &map_fogsbane[0][0][level];
		z = 3;
		break;
	case ID_MAP_GREYHAVEN:
		map1 = &map_greyhaven[0][0][level];
		z = 3;
		break;
	case ID_MAP_STORMCROW:
		map1 = &map_stormcrow[0][0][level];
		z = 3;
		break;
	case ID_MAP_WAVEGUIDE:
		map1 = &map_waveguide[0][0][level];
		z = 3;
		break;
	default:
		return;
	}
	backupmap1(map1, x, y, z, &map[0][0], 256, 256, 1);
}

//-----------------------------------------------------------------------------
// Name: backupmap1
// Desc: A generic MAP array copier
//-----------------------------------------------------------------------------

void MiscFunc::backupmap1(MAP *map1, int map1x, int map1y, int map1z,
				MAP *map2, int map2x, int map2y, int map2z){
	MAP tempmap;
	int map1size = map1z;
	int map2size = map2z;
	MAP *testmap1 = map1;
	MAP *testmap2 = map2;
	int x;
	int y;
	if(map1x < map2x){
		x = map1x;
	}
	else{
		x = map2x;
	}
	if(map1y < map2y){
		y = map1y;
	}
	else{
		y = map2y;
	}
	for(int b = 0; b < x; b++){
		testmap1 = map1;
		testmap1 = testmap1 + (b * map1y * map1z);
		testmap2 = map2;
		testmap2 += (b * map2y * map2z);
		for(int a = 0; a < y; a++){
			tempmap = *testmap2;
			*testmap1 = tempmap;
			testmap1+=map1size;
			testmap2+=map2size;
		}
	}
}

//-----------------------------------------------------------------------------
// Name: changelevel
// Desc: Load the map and level into memory
//-----------------------------------------------------------------------------

void MiscFunc::changelevel(int newlevel){
	
	backupmap();
	previousmap = currentmap;
	level = newlevel;
	
	createmapcoordinates();

	int x = 32;
	int y = 32;
	int z = 1;
	MAP *map1;
	
	switch(currentmap){
	case ID_MAP_BRIT:
		map1 = &map_brit[0][0];
		x = 256;
		y = 256;
		break;
	case ID_MAP_UNDER:
		map1 = &map_under[0][0];
		x = 256;
		y = 256;
		break;
	case ID_MAP_BRITAIN:
		map1 = &map_britain[0][0][level];
		z = 2;
		break;
	case ID_MAP_JHELOM:
		map1 = &map_jhelom[0][0][level];
		z = 2;
		break;
	case ID_MAP_MINOC:
		map1 = &map_minoc[0][0][level];
		z = 2;
		break;
	case ID_MAP_MOONGLOW:
		map1 = &map_moonglow[0][0][level];
		z = 2;
		break;
	case ID_MAP_NEWMAGINCIA:
		map1 = &map_newmagincia[0][0][level];
		z = 2;
		break;
	case ID_MAP_SKARABRAE:
		map1 = &map_skarabrae[0][0][level];
		z = 2;
		break;
	case ID_MAP_TRINSIC:
		map1 = &map_trinsic[0][0][level];
		z = 2;
		break;
	case ID_MAP_YEW:
		map1 = &map_yew[0][0][level];
		z = 2;
		break;
	case ID_MAP_CASTLEBLACKTHORN:
		map1 = &map_castleblackthorn[0][0][level];
		z = 5;
		break;
	case ID_MAP_CASTLEBRITISH:
		map1 = &map_castlebritish[0][0][level];
		z = 5;
		break;
	case ID_MAP_EMPATHABBEY:
		map1 = &map_empathabbey[0][0][level];
		z = 3;
		break;
	case ID_MAP_LYCAEUM:
		map1 = &map_lycaeum[0][0][level];
		z = 3;
		break;
	case ID_MAP_SERPENTSHOLD:
		map1 = &map_serpentshold[0][0][level];
		z = 3;
		break;
	case ID_MAP_GRENDEL:
		map1 = &map_grendel[0][0];
		break;
	case ID_MAP_IOLO:
		map1 = &map_iolo[0][0];
		break;
	case ID_MAP_SINVRAAL:
		map1 = &map_sinvraal[0][0];
		break;
	case ID_MAP_SUTEK:
		map1 = &map_sutek[0][0];
		break;
	case ID_MAP_BUCSDEN:
		map1 = &map_bucsden[0][0];
		break;
	case ID_MAP_COVE:
		map1 = &map_cove[0][0];
		break;
	case ID_MAP_EASTBRITAINNY:
		map1 = &map_eastbritainny[0][0];
		break;
	case ID_MAP_NORTHBRITAINNY:
		map1 = &map_northbritainny[0][0];
		break;
	case ID_MAP_PAWS:
		map1 = &map_paws[0][0];
		break;
	case ID_MAP_WESTBRITAINNY:
		map1 = &map_westbritainny[0][0];
		break;
	case ID_MAP_ARARAT:
		map1 = &map_ararat[0][0][level];
		z = 2;
		break;
	case ID_MAP_BORDERMARCH:
		map1 = &map_bordermarch[0][0][level];
		z = 2;
		break;
	case ID_MAP_FARTHING:
		map1 = &map_farthing[0][0];
		break;
	case ID_MAP_STONEKEEP:
		map1 = &map_stonekeep[0][0];
		break;
	case ID_MAP_WINDEMERE:
		map1 = &map_windemere[0][0];
		break;
	case ID_MAP_FOGSBANE:
		map1 = &map_fogsbane[0][0][level];
		z = 3;
		break;
	case ID_MAP_GREYHAVEN:
		map1 = &map_greyhaven[0][0][level];
		z = 3;
		break;
	case ID_MAP_STORMCROW:
		map1 = &map_stormcrow[0][0][level];
		z = 3;
		break;
	case ID_MAP_WAVEGUIDE:
		map1 = &map_waveguide[0][0][level];
		z = 3;
		break;
	default:
		return;
	}
	animate = true;
	backupmap1(&map[0][0], 256, 256, 1, map1, x, y, z);
}

//-----------------------------------------------------------------------------
// Name: changemap
// Desc: change the current map
//-----------------------------------------------------------------------------

void MiscFunc::changemap(HWND hWnd, int mapname){
	previousmode = currentmode;
	currentmode = EDITMAPS;
	int maxlevel = 0;
	if(previousmode != currentmode){
		changeoptionsmenu(hWnd);
		checkmapoptionsmenu(hWnd, CHECKHIGHLIGHTTILE);
	}
	wrap = false;
	maxX = 31;
	maxY = 31;
	
	currentmap = mapname;
	currentxpos = 15;
	currentypos = 30;
	level = 0;

	switch(mapname){
	case ID_MAP_BRIT:
	case ID_MAP_UNDER:
		wrap = true;
		maxX = 255;
		maxY = 255;
		currentxpos = 0;
		currentypos = 0;
		maxlevel = 1;
		break;
	case ID_MAP_BRITAIN:
	case ID_MAP_JHELOM:
	case ID_MAP_MINOC:
	case ID_MAP_MOONGLOW:
	case ID_MAP_NEWMAGINCIA:
	case ID_MAP_SKARABRAE:
	case ID_MAP_TRINSIC:
		maxlevel = 2;
		break;
	case ID_MAP_YEW:
		level = 1;
		maxlevel = 2;
		break;
	case ID_MAP_CASTLEBLACKTHORN:
	case ID_MAP_CASTLEBRITISH:
		level = 1;
		maxlevel = 5;
		break;
	case ID_MAP_EMPATHABBEY:
	case ID_MAP_LYCAEUM:
		maxlevel = 3;
		break;
	case ID_MAP_SERPENTSHOLD:
		level = 1;
		maxlevel = 3;
		break;
	case ID_MAP_GRENDEL:
	case ID_MAP_IOLO:
	case ID_MAP_SINVRAAL:
	case ID_MAP_SUTEK:
	case ID_MAP_BUCSDEN:
	case ID_MAP_COVE:
	case ID_MAP_EASTBRITAINNY:
	case ID_MAP_NORTHBRITAINNY:
	case ID_MAP_PAWS:
	case ID_MAP_WESTBRITAINNY:
		maxlevel = 1;
		break;
	case ID_MAP_ARARAT:
	case ID_MAP_BORDERMARCH:
		maxlevel = 2;
		break;
	case ID_MAP_FARTHING:
	case ID_MAP_STONEKEEP:
	case ID_MAP_WINDEMERE:
		maxlevel = 1;
		break;
	case ID_MAP_FOGSBANE:
	case ID_MAP_GREYHAVEN:
	case ID_MAP_STORMCROW:
	case ID_MAP_WAVEGUIDE:
		maxlevel = 3;
		break;
	default:
		break;
	}
	changelevelmenu(hWnd, maxlevel);
	changelevel(level);
	checklevelmenu(hWnd, level + 1);
	animate = true;
}

//-----------------------------------------------------------------------------
// Name: checku5directory
// Desc: Check to make sure that Ultima 5 is there, and load its data
//-----------------------------------------------------------------------------

bool MiscFunc::checku5directory(HWND hWnd){
	
	int tilenum;
	int currentdwelling;
	bool waterisall = false;
	bool loadfont = false;
	int isallwater = 0;
	int a,b,c;
	FILE *fp;
	
	/*
	The following requires way too much space.  Figure out how to shrink
	the memory requirements.  Try a BSP
	*/
	MAP map1[16][16][256];
	
	strcpy(filepath,path);
	strcat(filepath,"\\brit.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, BRITDAT);
		
		for(currentdwelling=0;currentdwelling<256;currentdwelling++){
			if(isallwater < 51){
				if(allwater[isallwater]==currentdwelling){
					waterisall=true;
					isallwater++;
				}
			}
			if(waterisall==true){
				for(a=0;a<16;a++){
					for(b=0;b<16;b++){
						map1[b][a][currentdwelling].highlighted = true;
						map1[b][a][currentdwelling].tilenum = 1;
					}
				}
			}
			else{
				for(a=0;a<16;a++){
					for(b=0;b<16;b++){
						tilenum = fgetc(fp);
						map1[b][a][currentdwelling].highlighted = false;
						map1[b][a][currentdwelling].tilenum = tilenum;
					}
				}
			}
			waterisall=false;
		}
		
		currentdwelling=0;
		for(c=0;c<16;c++){
			for(a=0;a<16;a++){
				for(b=0;b<16;b++){
					for(int d=0;d<16;d++){
						map_brit[b+d*16][a+16*c] = map1[b][a][currentdwelling+d];
					}
				}
			}
			currentdwelling+=16;
		}
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\under.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, UNDERDAT);
		for(currentdwelling=0;currentdwelling<256;currentdwelling++){
			for(b=0;b<16;b++){
				for(a=0;a<16;a++){
					tilenum = fgetc(fp);
					map1[b][a][currentdwelling].highlighted = false;
					map1[a][b][currentdwelling].tilenum = tilenum;
				}
			}
		}
		
		currentdwelling=0;
		for(c=0;c<16;c++){
			for(a=0;a<16;a++){
				for(b=0;b<16;b++){
					for(int d=0;d<16;d++){
						map_under[b+d*16][a+16*c] = map1[b][a][currentdwelling+d];
					}
				}
			}
			currentdwelling+=16;
		}
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\castle.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, CASTLEDAT);
		loadmap(&map_castlebritish[0][0][0],32,32,5,fp);
		loadmap(&map_castleblackthorn[0][0][0],32,32,5,fp);
		loadmap(&map_westbritainny[0][0],32,32,1,fp);
		loadmap(&map_northbritainny[0][0],32,32,1,fp);
		loadmap(&map_eastbritainny[0][0],32,32,1,fp);
		loadmap(&map_paws[0][0],32,32,1,fp);
		loadmap(&map_cove[0][0],32,32,1,fp);
		loadmap(&map_bucsden[0][0],32,32,1,fp);
		fclose(fp);
	}
	strcpy(filepath,path);
	strcat(filepath,"\\dwelling.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, DWELLINGDAT);
		loadmap(&map_fogsbane[0][0][0],32,32,3,fp);
		loadmap(&map_stormcrow[0][0][0],32,32,3,fp);
		loadmap(&map_greyhaven[0][0][0],32,32,3,fp);
		loadmap(&map_waveguide[0][0][0],32,32,3,fp);
		loadmap(&map_iolo[0][0],32,32,1,fp);
		loadmap(&map_sutek[0][0],32,32,1,fp);
		loadmap(&map_sinvraal[0][0],32,32,1,fp);
		loadmap(&map_grendel[0][0],32,32,1,fp);
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\keep.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, KEEPDAT);
		loadmap(&map_ararat[0][0][0],32,32,2,fp);
		loadmap(&map_bordermarch[0][0][0],32,32,2,fp);
		loadmap(&map_farthing[0][0],32,32,1,fp);
		loadmap(&map_windemere[0][0],32,32,1,fp);
		loadmap(&map_stonekeep[0][0],32,32,1,fp);
		loadmap(&map_lycaeum[0][0][0],32,32,3,fp);
		loadmap(&map_empathabbey[0][0][0],32,32,3,fp);
		loadmap(&map_serpentshold[0][0][0],32,32,3,fp);
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\towne.dat");
	if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(hWnd, TOWNEDAT);
		loadmap(&map_moonglow[0][0][0],32,32,2,fp);
		loadmap(&map_britain[0][0][0],32,32,2,fp);
		loadmap(&map_jhelom[0][0][0],32,32,2,fp);
		loadmap(&map_yew[0][0][0],32,32,2,fp);
		loadmap(&map_minoc[0][0][0],32,32,2,fp);
		loadmap(&map_trinsic[0][0][0],32,32,2,fp);
		loadmap(&map_skarabrae[0][0][0],32,32,2,fp);
		loadmap(&map_newmagincia[0][0][0],32,32,2,fp);
		fclose(fp);
	}
	
	/*	strcpy(filepath,path);
	strcat(filepath,"\\castle.tlk");
	if((fp = fopen(filepath, "rb"))!=NULL){
	changemenu(CASTLETALK);
	}
	fclose(fp);
	
	  strcpy(filepath,path);
	  strcat(filepath,"\\dwelling.tlk");
	  if((fp = fopen(filepath, "rb"))!=NULL){
	  changemenu(DWELLINGTALK);
	  }
	  fclose(fp);
	  
		strcpy(filepath,path);
		strcat(filepath,"\\keep.tlk");
		if((fp = fopen(filepath, "rb"))!=NULL){
		changemenu(KEEPTALK);
		}
		fclose(fp);
		
		  strcpy(filepath,path);
		  strcat(filepath,"\\towne.tlk");
		  if((fp = fopen(filepath, "rb"))!=NULL){
		  changemenu(TOWNETALK);
		  fclose(fp);
		  }
		  
			
	*/
	
	strcpy(filepath,path);
	strcat(filepath,"\\ibm.ch");
	if((fp = fopen(filepath, "rb"))!=NULL){
		loadfont = true;
		fclose(fp);
	}

	strcpy(filepath,path);
	strcat(filepath,"\\runes.ch");
	if((fp = fopen(filepath, "rb"))!=NULL){
		loadfont = true;
		fclose(fp);
	}

	if(loadfont == true){
		changemenu(hWnd, FONTDAT);
	}

	return true;
}

//-----------------------------------------------------------------------------
// Name: getPicture
// Desc: get the picture that the mouse is over
//-----------------------------------------------------------------------------

void MiscFunc::getPicture(int xpos,int ypos){
	int xposition;
	int yposition;
	bool placepicture = true;
	if(xpos >= 384 && xpos < 640 && ypos >= 272 && ypos < 400){
		xposition = xpos - 384;
		yposition = ypos - 272;
		xposition = xposition / 32;
		yposition = yposition / 32;
		currentedittile = (yposition * 8) + xposition + (currenttileselection * 32);
	}
	else if(xpos >= 16 && xpos < 384 && ypos >= 48 && ypos < 400){
		xposition = xpos - 16;
		yposition = ypos - 48;
		xposition = xposition / 32;
		yposition = yposition / 32;
		
		xposition = xposition - 5 + currentxpos;
		yposition = yposition - 5 + currentypos;
		if(wrap == true){
			if(xposition < 0){
				xposition = maxX + xposition + 1;
			}
			else if(xposition > maxX){
				xposition = xposition - maxX -1;
			}
			if(yposition < 0){
				yposition = maxY + yposition + 1;
			}
			else if(yposition > maxY){
				yposition = yposition - maxY - 1;
			}
		}
		else{
			if(xposition < 0 || xposition > maxX || yposition < 0 || yposition > maxY){
				placepicture = false;
			}
		}
		
		if(placepicture == true){
			if(map[xposition][yposition].highlighted == false){
				map[xposition][yposition].tilenum = currentedittile;
			}
		}
	}
}

//-----------------------------------------------------------------------------
// Name: initialize
// Desc: Initialize certain variables for the program
//-----------------------------------------------------------------------------

void MiscFunc::initialize(){

	MAPDISPLAY emptymap;
	emptymap.blocked = false;
	emptymap.highlighted = false;
	emptymap.isdark = false;
	emptymap.tilenum = 0;
	emptymap.visible = false;
	emptymap.visited = false;

	for(int a = 0; a < 256; a++){
		for(int b = 0; b < 256; b++){
			map[a][b].tilenum = 0;
		}
	}
	for(a = 0; a < 13; a++){
		for(int b = 0; b < 13; b++){
			displaymap[a][b] = emptymap;
		}
	}
}

//-----------------------------------------------------------------------------
// Name: loadmap
// Desc: Load a map into memory
//-----------------------------------------------------------------------------

void MiscFunc::loadmap(MAP *mymap, int x, int y, int z, FILE *fp){
	int tilenum = 0;
	int mysize = z*y;
	MAP *test;
	for(int c = 0; c < z; c++){
		for(int b = 0; b < y; b++){
			test = mymap;
			test = test + ( b * z ) + c;
			for(int a = 0; a < x; a++){
				tilenum = fgetc(fp);
				test->tilenum = tilenum;
				test->highlighted = false;
				test+=mysize;
			}
		}
	}
}

void MiscFunc::savemap(MAP* map1, int x, int y, int z, FILE* fp){
	MAP* map2;
	for(int c = 0; c < z; c++){
		for(int b = 0; b < y; b++){
			map2 = map1;
			map2 += c;
			map2 += (b * z);
			for(int a = 0; a < x; a++){
				fputc((*map2).tilenum, fp);
				map2+=(y*z);
			}
		}
	}
}

//-----------------------------------------------------------------------------
// Name: saveu5directory
// Desc: Saves all of the map *.dat files
//-----------------------------------------------------------------------------

void MiscFunc::saveu5directory(HWND hWnd){
	int currentdwelling;
	int map1[16][16][256];
	bool waterisall = false;
	int isallwater = 0;
	int a,b,c;
	FILE *fp;

	backupmap();
	
	strcpy(filepath,path);
	strcat(filepath,"\\brit.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		currentdwelling=0;
		for(c=0;c<16;c++){
			for(a=0;a<16;a++){
				for(b=0;b<16;b++){
					map1[b][a][currentdwelling]		=	map_brit[b][a+16*c].tilenum;
					map1[b][a][currentdwelling+1]	=	map_brit[b+16][a+16*c].tilenum;
					map1[b][a][currentdwelling+2]	=	map_brit[b+32][a+16*c].tilenum;
					map1[b][a][currentdwelling+3]	=	map_brit[b+48][a+16*c].tilenum;
					map1[b][a][currentdwelling+4]	=	map_brit[b+64][a+16*c].tilenum;
					map1[b][a][currentdwelling+5]	=	map_brit[b+80][a+16*c].tilenum;
					map1[b][a][currentdwelling+6]	=	map_brit[b+96][a+16*c].tilenum;
					map1[b][a][currentdwelling+7]	=	map_brit[b+112][a+16*c].tilenum;
					map1[b][a][currentdwelling+8]	=	map_brit[b+128][a+16*c].tilenum;
					map1[b][a][currentdwelling+9]	=	map_brit[b+144][a+16*c].tilenum;
					map1[b][a][currentdwelling+10]	=	map_brit[b+160][a+16*c].tilenum;
					map1[b][a][currentdwelling+11]	=	map_brit[b+176][a+16*c].tilenum;
					map1[b][a][currentdwelling+12]	=	map_brit[b+192][a+16*c].tilenum;
					map1[b][a][currentdwelling+13]	=	map_brit[b+208][a+16*c].tilenum;
					map1[b][a][currentdwelling+14]	=	map_brit[b+224][a+16*c].tilenum;
					map1[b][a][currentdwelling+15]	=	map_brit[b+240][a+16*c].tilenum;
				}
			}
			currentdwelling+=16;
		}
		for(currentdwelling=0;currentdwelling<256;currentdwelling++){
			if(isallwater < 51){
				if(allwater[isallwater]==currentdwelling){
					waterisall=true;
					isallwater++;
				}
			}
			if(waterisall == false){
				for(a=0;a<16;a++){
					for(b=0;b<16;b++){
						c=map1[b][a][currentdwelling];
						fputc(c,fp);
						
					}
				}
			}
			waterisall=false;
		}
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\under.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		currentdwelling=0;
		for(c=0;c<16;c++){
			for(a=0;a<16;a++){
				for(b=0;b<16;b++){
					map1[b][a][currentdwelling]		=	map_under[b][a+16*c].tilenum;
					map1[b][a][currentdwelling+1]	=	map_under[b+16][a+16*c].tilenum;
					map1[b][a][currentdwelling+2]	=	map_under[b+32][a+16*c].tilenum;
					map1[b][a][currentdwelling+3]	=	map_under[b+48][a+16*c].tilenum;
					map1[b][a][currentdwelling+4]	=	map_under[b+64][a+16*c].tilenum;
					map1[b][a][currentdwelling+5]	=	map_under[b+80][a+16*c].tilenum;
					map1[b][a][currentdwelling+6]	=	map_under[b+96][a+16*c].tilenum;
					map1[b][a][currentdwelling+7]	=	map_under[b+112][a+16*c].tilenum;
					map1[b][a][currentdwelling+8]	=	map_under[b+128][a+16*c].tilenum;
					map1[b][a][currentdwelling+9]	=	map_under[b+144][a+16*c].tilenum;
					map1[b][a][currentdwelling+10]	=	map_under[b+160][a+16*c].tilenum;
					map1[b][a][currentdwelling+11]	=	map_under[b+176][a+16*c].tilenum;
					map1[b][a][currentdwelling+12]	=	map_under[b+192][a+16*c].tilenum;
					map1[b][a][currentdwelling+13]	=	map_under[b+208][a+16*c].tilenum;
					map1[b][a][currentdwelling+14]	=	map_under[b+224][a+16*c].tilenum;
					map1[b][a][currentdwelling+15]	=	map_under[b+240][a+16*c].tilenum;
				}
			}
			currentdwelling+=16;
		}
		for(currentdwelling=0;currentdwelling<256;currentdwelling++){
			for(a=0;a<16;a++){
				for(b=0;b<16;b++){
					c=map1[b][a][currentdwelling];
					fputc(c,fp);
					
				}
			}
		}
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\castle.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		//changemenu(hWnd, CASTLEDAT);
		savemap(&map_castlebritish[0][0][0],32,32,5,fp);
		savemap(&map_castleblackthorn[0][0][0],32,32,5,fp);
		savemap(&map_westbritainny[0][0],32,32,1,fp);
		savemap(&map_northbritainny[0][0],32,32,1,fp);
		savemap(&map_eastbritainny[0][0],32,32,1,fp);
		savemap(&map_paws[0][0],32,32,1,fp);
		savemap(&map_cove[0][0],32,32,1,fp);
		savemap(&map_bucsden[0][0],32,32,1,fp);
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\dwelling.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		savemap(&map_fogsbane[0][0][0],32,32,3,fp);
		savemap(&map_stormcrow[0][0][0],32,32,3,fp);
		savemap(&map_greyhaven[0][0][0],32,32,3,fp);
		savemap(&map_waveguide[0][0][0],32,32,3,fp);
		savemap(&map_iolo[0][0],32,32,1,fp);
		savemap(&map_sutek[0][0],32,32,1,fp);
		savemap(&map_sinvraal[0][0],32,32,1,fp);
		savemap(&map_grendel[0][0],32,32,1,fp);
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\keep.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		savemap(&map_ararat[0][0][0],32,32,2,fp);
		savemap(&map_bordermarch[0][0][0],32,32,2,fp);
		savemap(&map_farthing[0][0],32,32,1,fp);
		savemap(&map_windemere[0][0],32,32,1,fp);
		savemap(&map_stonekeep[0][0],32,32,1,fp);
		savemap(&map_lycaeum[0][0][0],32,32,3,fp);
		savemap(&map_empathabbey[0][0][0],32,32,3,fp);
		savemap(&map_serpentshold[0][0][0],32,32,3,fp);
		fclose(fp);
	}
	
	strcpy(filepath,path);
	strcat(filepath,"\\towne.dat");
	if((fp = fopen(filepath, "wb"))!=NULL){
		savemap(&map_moonglow[0][0][0],32,32,2,fp);
		savemap(&map_britain[0][0][0],32,32,2,fp);
		savemap(&map_jhelom[0][0][0],32,32,2,fp);
		savemap(&map_yew[0][0][0],32,32,2,fp);
		savemap(&map_minoc[0][0][0],32,32,2,fp);
		savemap(&map_trinsic[0][0][0],32,32,2,fp);
		savemap(&map_skarabrae[0][0][0],32,32,2,fp);
		savemap(&map_newmagincia[0][0][0],32,32,2,fp);
		fclose(fp);
	}
}
